package dk.nsp.idsas.dao;

import dk.nsp.idsas.util.ErrorMessages;
import dk.nsp.idsas.util.SoapFaultGenerator;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.CreateBlurringRequestType;

import dk.nsp.idsas.dao.entity.BlurringEntity;
import dk.nsp.idsas.security.model.IdsasActor;

public class CreateBlurringRequestTypeMapper {
    public static BlurringEntity toBlurringEntity(CreateBlurringRequestType blurringRequest, IdsasActor actor) {

        if (blurringRequest.getPatientId().getId() == null) {
            throw SoapFaultGenerator.generateSOAPFault(true, ErrorMessages.missingParameterError("PatientId"));
        }

        if (blurringRequest.getPatientId().getClassification() == null) {
            throw SoapFaultGenerator.generateSOAPFault(true, ErrorMessages.missingParameterError("PatientId classification"));
        }

        if (blurringRequest.getEndDateTime() == null) {
            throw SoapFaultGenerator.generateSOAPFault(true, ErrorMessages.missingParameterError("EndDateTime"));
        }

        return new BlurringEntity(
            blurringRequest.getPatientId().getId(),
            blurringRequest.getPatientId().getClassification().value(),
            actor.getCvr(),
            "CVR",
            blurringRequest.getEndDateTime().toGregorianCalendar().toZonedDateTime().toInstant());
    }
}
