package dk.nsp.idsas.dao.entity;

import java.time.Instant;
import java.util.Objects;

public class BlurringEntity {
    private String patientId;
    private String patientIdType;
    private String organisationId;
    private String organisationIdType;
    private Instant expiryDate;

    public BlurringEntity() {
    }

    public BlurringEntity(String patientId, String patientIdType, String organisationId, String organisationIdType, Instant expiryDate) {
        this.patientId = patientId;
        this.patientIdType = patientIdType;
        this.organisationId = organisationId;
        this.organisationIdType = organisationIdType;
        this.expiryDate = expiryDate;
    }

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getPatientIdType() {
        return patientIdType;
    }

    public void setPatientIdType(String patientIdType) {
        this.patientIdType = patientIdType;
    }

    public String getOrganisationId() {
        return organisationId;
    }

    public void setOrganisationId(String organisationId) {
        this.organisationId = organisationId;
    }

    public String getOrganisationIdType() {
        return organisationIdType;
    }

    public void setOrganisationIdType(String organisationIdType) {
        this.organisationIdType = organisationIdType;
    }

    public Instant getExpiryDate() {
        return expiryDate;
    }

    public void setExpiryDate(Instant expiryDate) {
        this.expiryDate = expiryDate;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BlurringEntity that = (BlurringEntity) o;
        return Objects.equals(patientId, that.patientId) && Objects.equals(patientIdType, that.patientIdType) && Objects.equals(organisationId, that.organisationId) && Objects.equals(organisationIdType, that.organisationIdType) && Objects.equals(expiryDate, that.expiryDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(patientId, patientIdType, organisationId, organisationIdType, expiryDate);
    }

    @Override
    public String toString() {
        return "BlurringEntity{" +
                "patientId='" + patientId + '\'' +
                ", patientIdType='" + patientIdType + '\'' +
                ", organisationId='" + organisationId + '\'' +
                ", organisationIdType='" + organisationIdType + '\'' +
                ", expiryDate=" + expiryDate +
                '}';
    }
}
