package dk.nsp.idsas.util;

import org.apache.log4j.Logger;

import javax.xml.namespace.QName;
import javax.xml.soap.*;
import javax.xml.ws.soap.SOAPFaultException;

public class SoapFaultGenerator {
	private static final Logger logger = Logger.getLogger(SoapFaultGenerator.class);
	private static final String namespace = "http://sundhedsdatastyrelsen.dk/identitetssloering/";
	
	public static SOAPFaultException generateSOAPFault(boolean client, String message) {
		try {
			SOAPFault fault;
			final String faultMessage = message != null ? message : "No description";
			SOAPFactory factory = SOAPFactory.newInstance(SOAPConstants.SOAP_1_1_PROTOCOL);
			fault = factory.createFault(faultMessage, new QName(SOAPConstants.URI_NS_SOAP_1_1_ENVELOPE, client ? "Client" : "Server"));
			final Detail detail = fault.addDetail();
			final DetailEntry detailEntry = detail.addDetailEntry(new QName(namespace, "FaultCode"));
			detailEntry.addTextNode(message);
			return new SOAPFaultException(fault);
		} catch (Exception e) {
			throw new RuntimeException("Error generating SOAPFault: " + e.getMessage());
		}
	}

}
