package dk.nsp.idsas.dao;

import dk.nsp.idsas.setup.DataSourceTestConfiguration;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import javax.sql.DataSource;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

@RunWith(SpringRunner.class)
@ContextConfiguration(classes = {DataSourceTestConfiguration.class})
public class AlivenessDaoTest {
    @Autowired
    DataSource dataSource;

    @Test
    public void isAlive_WhenDatabaseIsResponding_ReturnsTrue() {
        AlivenessDao alivenessDao = new AlivenessDao(dataSource);

        assertTrue(alivenessDao.isAlive());
    }

    @Test
    public void isAlive_WhenDatabaseIsNotResponding_ReturnsFalse() {
        DataSource nonRespondingDataSource = Mockito.mock(DataSource.class);
        AlivenessDao alivenessDao = new AlivenessDao(nonRespondingDataSource);

        assertFalse(alivenessDao.isAlive());
    }
}